#!/bin/sh
Def() { eval "[ -n \"\$$1\" ] || $1=\$2"; }

[ -n "$YANDERE_BRANCH" ] && YANDERE_BRANCH="/${YANDERE_BRANCH}"

Def YANDERE_BRANCH_URI "lp:yandere${YANDERE_BRANCH}"
Def PHARO_BRANCH_URI   "http://svn.pharo.org/trunk"

Def YANDERE_SCM "bzr"
Def PHARO_SCM   "svn"


die() {
	local err="$1"; shift
	[ -n "$err" ] || err='Unexpected error!'
	echo "$err" >&2
	exit 1
}

COS() {
	local Target="$1"; shift
	local    Var="$1"; shift
	if [ -e "$Target" ]; then
		echo 'switch'
		pushd "$Target" &>/dev/null || die "Failed to change to $Target directory"
		eval "\${${Var}_SCM} switch   --quiet \${${Var}_BRANCH_URI}" || die "Failed to switch $Target repository"
		popd &>/dev/null || die
	else
		echo 'checkout'
		eval "\${${Var}_SCM} checkout --quiet \${${Var}_BRANCH_URI} \$Target" || die "Failed to checkout $Target"
	fi
}

echo -n 'Yandere game... '
COS 'yandere'         YANDERE
echo -n 'Pharo framework... '
COS 'pharo'           PHARO
echo 'Done!'
