#!/usr/bin/php
<?php
// PHP 5 >= 5.2.0 || PECL json >= 1.2.0
$nick = 'Game';
{
	for ($i = 1; $i < $argc; ++$i)
	{
		switch ($argv[$i]) {
		case '--font-bold':
			define(BOLD, $argv[++$i]);
			break;
		case '--font-reverse':
			define(REVERSE, $argv[++$i]);
			break;
		case '--nick':
			$nick = $argv[++$i];
			break;
		}
	}
}

require('pharo/mods-available/array/array.php');
require('pharo/mods-available/get-set/get-set.php');

function add_handler($from, $to) {
	echo "H\t$from\t$to\n";
}
function handle($from, $to) {
	return add_handler($from, $to);
}

function fget_value($f) {
	$M = explode("\t", "-\t" . rtrim(fgets($f)));
	switch ($M[1]) {
	case 'a':
		$i = intval($M[2]);
		$a = array();
		for ( ; $i; --$i)
			$a[] = fget_value($f);
		return $a;
	case 'h':
		$i = intval($M[2]);
		$a = array();
		for ( ; $i; --$i)
		{
			$e = fget_value($f);
			$a[$e] = fget_value($f);
		}
		return $a;
	case 'i':
		return
		intval($M[2]);
	case 's':
		$i = intval($M[2]);
		if (!$i)
			$s = '';
		else
		$s = fread($f, $i);
		assert(fgets($f) === "\n");
		return $s;
	case '*s':
		global $servers;
		return
		$servers[$M[2]];
	case '*u':
		global $servers;
		$s = $servers[$M[2]];
		return
		$s->user($M[3]);
	}
}

require('fake-pharo.php');
require('useful-tools.php');

define(BOLD, "");
define(REVERSE, "");

require_once (dirname(__FILE__).'/yandere/irc-yandere.php');

$events = array();
$servers = array();
$DefChanStrs = array();

class yanderebot {
	function yanderebot($nick) {
		$this->custom_vars = new stdClass;
		$this->server = $this;
		$this->irc_users = array();
		$this->irc_users_s = array();
		if (!isset($nick))
			$nick = 'Game';
		$this->nick = $nick;
		$this->ChanStrs = array();
		$this->ChanStrs["\0"] = array();
	}
	
	function call($what) {
		$irc_call_args = array_slice(func_get_args(), 1);
		$what = preg_replace('/^yandere\/(.+)$/', 'functions/$1.php', $what);
		global $to, $from;
		return require("yandere/$what");
	}
	
	function schedule_event($when, $event) {
		global $events;
		$events[] = array($when, $event, $this);
	}
	
	function user($who) {
		if (isset($this->irc_users_s[$who]))
			return $this->irc_users_s[$who];
		if (!isset($this->irc_users[$who]))
		{
			$whoS = preg_replace('/[^\w!-\/:-@\[-^{-}-]+/', '_', $who);
			$this->irc_users_s[$whoS] =
			$this->irc_users[$who] = new fake_irc_user($who, $whoS);
		}
		return $this->irc_users[$who];
	}
	function channel($c) {
		return $c;
	}
	
	function channel_strings($channel, $s) {
		$CS = $this->ChanStrs[$channel];
		if (!isset($CS))
			$CS = array();
		$CS += $this->ChanStrs["\0"];
		global $DefChanStrs;
		$CS += $DefChanStrs;
		$CS += array (
			'Bot' => $this->nick,
			'(BOLD)'    => BOLD,
			'(REVERSE)' => REVERSE,
		);
		if (isset($s) && !is_array($s))
			return $CS[$s];
		return $CS;
	}
	
	function output($x, $s) {
		echo "M\t$x\t$s\n";
	}
	
	function notice($x, $s) {
		echo "N\t$x\t$s\n";
	}
	
	function is_admin($who) {
		return true; // FIXME
		return false;
	}
	
}

function handle_input($text) {
	if ($text === '')
		return;
	$M = explode("\t", "-\t$text");
	$M[0] = $text;
	switch ($M[1]) {
	case '#':
		// Ignore comment lines :)
		break;
	case '"':
		global $servers;
		global $DefChanStrs;
		if (count($M) < 3)
			$CS =& $DefChanStrs;
		else
		{
		$server = $servers[$M[2]];
		if (count($M) < 4)
			$channel = "\0";
		else
		$channel = $N[3];
			$CS =& $server->ChanStrs[$channel];
		}
		$CS = fget_value(STDIN);
		break;
	case '=':
		switch ($M[2]) {
		case '[':
			global $from;
			$v =& $from;
			break;
		case ']':
			global $to;
			$v =& $to;
			break;
		case 'S':
			global $bot;
			$v =& $bot;
			break;
		default:
			echo "E VarUnknown\n";
			return;
		}
		$v = fget_value(STDIN);
		break;
	case 'H':
		$h = $M[2];
		$args = fget_value(STDIN);
		$h($args);
		break;
	case 'S':
		global $servers;
		$s = $M[2];
		$snick = $M[3];
		if (isset($servers[$s]))
			break;
		if (!isset($snick))
		{
			global $nick;
			$snick = $nick;
		}
		$servers[$s] = new yanderebot($snick);
		break;
	case 'x':
		exit(0);
	default:
		echo "E CmdUnknown\n";
	}
}

function main() {
	global $events;
	while (true)
	{
		$nextevent = null;
		for ($i = 0; $i < count($events); ++$i)
		{
			if ($events[$i] === false)
				continue;
			if ($events[$i][0] > ($now = time()))
			{
				$mydelay = ($events[$i][0] - $now) + 1;
				if (is_null($nextevent) || $nextevent > $mydelay)
					$nextevent = $mydelay;
				continue;
			}
			call_user_func_array(array(&$events[$i][2], 'call'), $events[$i][1]);
			$events[$i] = false;
			// FIXME: this leaks array entries :)
		}
		$have_stdin = stream_select($r = array(STDIN), $w = null, $e = null, $nextevent);
		if ($have_stdin)
			handle_input(rtrim(fgets(STDIN)));
	}
}

main();
